﻿using System;

namespace Janken
{
    class EnemyDefault : IEnemy
    {
        // デフォルト閾値
        protected const int DefaultRock = 333;
        protected const int DefaultScissors = 666;
        protected const int DefaultPaper = 1000;

        // 閾値
        protected int rock = DefaultRock;
        protected int scissors = DefaultScissors;
        protected int paper = DefaultPaper;

        // 閾値補正値
        protected int reviseRock = 0;
        protected int reviseScissors = 0;
        protected int revisePaper = 0;

        // ランダム値
        protected Random random = null;

        // 名前
        public string Name { get; set; }

        // コンストラクタ
        public EnemyDefault()
        {
            // ランダム値初期化
            random = new Random();

            // リソースから名前取得
            Name = Properties.Resources.DefaultEnemyNameString;

            // ランダム補正
            randomCorrection(200);
        }

        // ランダム値で閾値を補正する
        protected void randomCorrection(int randomWidth)
        {
            int upper = randomWidth / 2;
            int lower = -upper;

            // ランダム値取得
            reviseRock = random.Next(lower, upper);
            reviseScissors = random.Next(lower, upper);
            revisePaper = random.Next(lower, upper);

            // 閾値にランダム補正値を加算
            rock = rock + reviseRock;
            scissors = scissors + reviseScissors;
            paper = paper + revisePaper;
        }

        // ランダム値から選択手を決定する
        public int Janken(int userValue)
        {
            // ランダム値取得
            int randomValue = random.Next(paper);

            if (randomValue >= 0 && randomValue <= rock)
            {
                return JankenConst.Rock;
            }
            else if (randomValue > rock && randomValue <= scissors)
            {
                return JankenConst.Scissors;
            }
            else if (randomValue > scissors && randomValue <= paper)
            {
                return JankenConst.Paper;
            }

            return JankenConst.Rock;
        }
    }
}
